diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
index 42addc6c8..e32728ada 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -25,7 +25,7 @@ import java.util.ArrayList;
 import java.util.List;
 import java.util.function.Supplier;
 
-public class BlockLogicStatue extends BlockLogic {
+public class BlockLogicStatue extends BlockLogic implements BlockLogic.MatcherEntityEquivalency<TileEntityStatue> {
     private final boolean isBottom;
 
     public final @Nullable Supplier<@NotNull Item> droppedItem;
@@ -264,19 +264,27 @@ public class BlockLogicStatue extends BlockLogic {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        assert world.getBlockType(thisPos) == this.block;
-        final var thatBlock = world.getBlockType(thatPos);
-        if (thatBlock != this.block) return false;
-        final var that = (BlockLogicStatue) thatBlock.getLogic();
-
-        final var query = new TilePos();
-        if (!(world.getTileEntity(this.isBottom ? thisPos : thisPos.down(query)) instanceof TileEntityStatue thisStatue) ||
-            !(world.getTileEntity(that.isBottom ? thatPos : thatPos.down(query)) instanceof TileEntityStatue thatStatue))
-            return false;
-        
+    public boolean isEquivalent(
+        @NotNull WorldSource world,
+        @NotNull TilePosc thisPos, @NotNull TilePosc thatPos,
+        @NotNull Block<?> thatBlock
+    ) {
+        return (this.isBottom)
+            ? super.isEquivalent(world, thisPos, thatPos, thatBlock)
+            : super.isEquivalent(world, thisPos.down(new TilePos()), thatPos.down(new TilePos()), thatBlock);
+    }
+
+    @Override
+    public @NotNull Class<TileEntityStatue> getEntityEquivalencyClass() {
+        return TileEntityStatue.class;
+    }
+
+    @Override
+    public boolean isEquivalentEntityForMatcherImpl(
+        @NotNull TileEntityStatue thisStatue, @NotNull TileEntityStatue thatStatue
+    ) {
         if (thisStatue.getPose() != thatStatue.getPose()) return false;
-        
+
         // we assume (but not assert) all stacks to be of size 1
         // TODO: Item.isEquivalent(ItemStack)
         if (!ItemStack.areItemsEqual(thisStatue.getHeldItem(), thatStatue.getHeldItem())) return false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
index 8af566e81..ac5abde80 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
@@ -131,9 +131,4 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable {
         }
         return true;
     }
-
-    @Override
-    protected int getMatcherEquivalenceData(int data) {
-        return 0;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java
index b904c1c85..4bbc1e14d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java
@@ -32,7 +32,7 @@ public class BlockLogicSulfur extends BlockLogic {
 	public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
 		return switch (dropCause) {
 			case PICK_BLOCK, SILK_TOUCH -> new ItemStack[]{new ItemStack(this)};
-			default -> new ItemStack[]{new ItemStack(Items.SULFUR, 1 + world.rand.nextInt(2))};
+			default -> new ItemStack[]{new ItemStack(Items.SULFUR, 4)};
 		};
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
index 04f08add0..a9753bd77 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block;
 
 import it.unimi.dsi.fastutil.longs.Long2IntOpenHashMap;
 import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.block.entity.TileEntityThermalVent;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
@@ -9,11 +10,9 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.particle.ParticleEmitterRange;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 
 import java.util.List;
@@ -36,11 +35,11 @@ public class BlockLogicThermalVent extends BlockLogic {
     public BlockLogicThermalVent(final @NotNull Block<?> block) {
         super(block, Materials.BASALT);
         block.setTicking(true);
+        block.withEntity(TileEntityThermalVent::new);
     }
 
     @Override
     public void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
-        if (world.isClientSide) return;
         final int state = getVentState(world.getBlockData(tilePos));
 
         final double xPos = (double) tilePos.x() + 0.5D;
@@ -51,12 +50,12 @@ public class BlockLogicThermalVent extends BlockLogic {
             return;
         }
 
-        world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 1, 1000, true);
+        world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 1, 1000, false);
 
         if (hasVentBelow(world, tilePos) && state >= VENTING_STATE - 1) {
             for (int i = 0; i < 4; i++) {
-                world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 0, 1000.0, true);
-                world.spawnParticle("smoke", xPos + rand.nextFloat() - 0.5D, yPos, zPos + rand.nextFloat() - 0.5D, 0.0D, 0.005D, 0.0D, 1, 1000.0, true);
+                world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 0, 1000.0, false);
+                world.spawnParticle("smoke", xPos + rand.nextFloat() - 0.5D, yPos, zPos + rand.nextFloat() - 0.5D, 0.0D, 0.005D, 0.0D, 1, 1000.0, false);
             }
         }
     }
@@ -72,16 +71,6 @@ public class BlockLogicThermalVent extends BlockLogic {
         return Block.hasLogicClass(world.getBlockType(tilePos.down(new TilePos())), BlockLogicThermalVent.class);
     }
 
-    @Override
-    protected boolean isSameBlockForMatcher(@NotNull Block<?> other) {
-        return Block.hasLogicClass(other, BlockLogicThermalVent.class);
-    }
-
-    @Override
-    protected int getMatcherEquivalenceData(int data) {
-        return 0;
-    }
-
     @Override
     public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!hasVentBelow(world, tilePos) && getVentState(world.getBlockData(tilePos)) != DORMANT_STATE) {
@@ -198,9 +187,4 @@ public class BlockLogicThermalVent extends BlockLogic {
             world.setBlockData(tilePos, hasVentBelow(world, tilePos) ? world.rand.nextInt(VENTING_STATE) : DORMANT_STATE);
         }
     }
-
-    @Override
-    public @Nullable ParticleEmitterRange getParticleEmitterRange() {
-        return ParticleEmitterRange.FAR;
-    }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTimer.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTimer.java
index 068ddbb61..ab3dbeafc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTimer.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTimer.java
@@ -25,7 +25,7 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLogicTimer extends BlockLogic implements ISupportable {
+public class BlockLogicTimer extends BlockLogic implements ISupportable, BlockLogic.MatcherDataEquivalency.Masked {
     public static final double[] torchPosOffset = {
         -0.0625D, 0.0625D, 0.1875D, 0.3125D
     };
@@ -50,8 +50,8 @@ public class BlockLogicTimer extends BlockLogic implements ISupportable {
     public static final int MASK_TICK_DELAY = 0b0000_1100;
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & (MASK_TICK_DELAY | ~MASK_DIRECTION);
+    public int getMatcherDataEquivalencyMask() {
+        return ~MASK_DIRECTION;
     }
 
     public BlockLogicTimer(@NotNull Block<?> block) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
index 2b7a5f1b5..41b10f73c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
@@ -34,11 +34,6 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable {
         block.setTicking(true);
     }
 
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & ~MASK_DIRECTION;
-    }
-
     @Override
     public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
index 64912292e..5196b9ec6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
@@ -21,11 +21,6 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
         this.torchActive = isActive;
     }
 
-    @Override
-    protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
-        return other.getLogic() instanceof BlockLogicTorchRedstone rtorch && rtorch.torchActive == this.torchActive;
-    }
-
     @Override
     public int tickDelay() {
         return 2;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
index 4fc8ef0c6..0de34e5db 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
@@ -26,7 +26,7 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
-public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
+public class BlockLogicTrapDoor extends BlockLogic implements IPaintable, BlockLogic.MatcherDataEquivalency {
     public static final int DIRECTION_SOUTH = 0;
     public static final int DIRECTION_NORTH = 1;
     public static final int DIRECTION_EAST = 2;
@@ -44,9 +44,10 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     }
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        assert (MASK_OPEN << 1) == MASK_UPPER_HALF;
-        return data & ~(MASK_DIRECTION | ((data & MASK_OPEN) << 1));
+    public boolean isEquivalentDataForMatcherImpl(int thisData, int thatData) {
+        if ((thisData & MASK_OPEN) != (thatData & MASK_OPEN)) return false;
+        if ((thisData & MASK_OPEN) != 0) return true;
+        return (thisData & MASK_UPPER_HALF) == (thatData & MASK_UPPER_HALF);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
index 2ccb6b7a0..cd98d5f9e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
@@ -53,4 +53,12 @@ public class BlockLogicTrapDoorPainted extends BlockLogicTrapDoor implements IPa
     public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         IPainted.super.setColor(world, tilePos, color);
     }
+
+    public static final int MASK_COLOR = 0xF0;
+
+    @Override
+    public boolean isEquivalentDataForMatcherImpl(int thisData, int thatData) {
+        if ((thisData & MASK_COLOR) != (thatData & MASK_COLOR)) return false;
+        return super.isEquivalentDataForMatcherImpl(thisData, thatData);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
index 0bfd57ee8..ef39e7d8e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
@@ -16,11 +16,6 @@ public abstract class BlockLogicVeryRotatable
         super(block, material);
     }
 
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & ~MASK_DIRECTION;
-    }
-
     @Override
     public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         final @NotNull Direction direction = mob.getPlacementDirection(side).opposite();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
index 3621bd2a6..65755d6a8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
@@ -9,7 +9,6 @@ import net.minecraft.core.current.util.BlockState;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -26,7 +25,7 @@ import java.util.Random;
 import java.util.Set;
 import java.util.function.Predicate;
 
-public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
+public class BlockLogicWireRedstone extends BlockLogic implements ISupportable, BlockLogic.MatcherDataEquivalency.Masked {
     public static final int SIGNAL_MIN = 0;
     public static final int SIGNAL_MAX = 15;
     public static final int SIGNAL_STEP = 1;
@@ -267,8 +266,8 @@ public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
     private int checkTarget(@NotNull World world, @NotNull TilePos tilePos, int sourceStrength) {
         if(world.getBlockType(tilePos) == Blocks.CONDUIT){
             int cData = world.getBlockData(tilePos);
-            int cStrength = (cData >> BlockLogicConduit.POWER_SHIFT) & BlockLogicConduit.POWER_MASK;
-            return Math.max(BlockLogicConduit.signalConverter(cStrength, true), sourceStrength);
+            int cStrength = BlockLogicConduit.getPower(cData);
+            return Math.max(BlockLogicConduit.signalConverter(cStrength), sourceStrength);
         }
 
         if (world.getBlockType(tilePos) != this.block) {
@@ -409,6 +408,7 @@ public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
 
     public static boolean shouldConnectTo(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
         // TODO make connections handled per block rather then by the dust
+        //  if handling this, the conduit has the same issue, and should be fixed in tandem with the dust
         final Block<?> block = source.getBlockType(tilePos);
         if (block == null) {
             return false;
@@ -559,4 +559,9 @@ public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
     public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return side == Side.BOTTOM ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
     }
+
+    @Override
+    public int getMatcherDataEquivalencyMask() {
+        return MASK_POWER;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index adae62878..d8009b276 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1488,7 +1488,7 @@ public final class Blocks {
         .withSound(BlockSounds.SAND).withHardness(0.7F)
         .withTags(BlockTags.MINEABLE_BY_SHOVEL, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.INFINITE_BURN_SULFURIC);
     public static final Block<?> BRIMSTONE = register("brimstone", "minecraft:block/brimstone", 1086, block -> new BlockLogicBrimstone(block, Materials.STONE))
-        .withSound(BlockSounds.STONE).withHardness(1.8F).withOverrideColor(MaterialColor.paintedBlack)
+        .withSound(BlockSounds.STONE).withHardness(1F).withOverrideColor(MaterialColor.paintedBlack)
         .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.NETHER_MOBS_SPAWN, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.INFINITE_BURN_SULFURIC);
     public static final Block<?> SLAB_BRIMSTONE = register("slab.brimstone", "minecraft:block/slab_brimstone", 1087, block -> new BlockLogicSlab(block, BRIMSTONE))
         .withSound(BlockSounds.STONE).withLitInteriorSurface(true).withOverrideColor(MaterialColor.paintedBlack)
@@ -1497,7 +1497,7 @@ public final class Blocks {
         .withSound(BlockSounds.STONE).withLitInteriorSurface(true).withOverrideColor(MaterialColor.paintedBlack)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN_SULFURIC);
     public static final Block<?> BRICK_BRIMSTONE = register("brick.brimstone", "minecraft:block/brick_brimstone", 1089, block -> new BlockLogicBrimstone(block, Materials.STONE))
-        .withSound(BlockSounds.STONE).withHardness(1.8F).withOverrideColor(MaterialColor.paintedBlack)
+        .withSound(BlockSounds.STONE).withHardness(1F).withOverrideColor(MaterialColor.paintedBlack)
         .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.NETHER_MOBS_SPAWN, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.INFINITE_BURN_SULFURIC);
     public static final Block<?> SLAB_BRICK_BRIMSTONE = register("slab.brick.brimstone", "minecraft:block/slab_brick_brimstone", 1090, block -> new BlockLogicSlab(block, BRICK_BRIMSTONE))
         .withSound(BlockSounds.STONE).withLitInteriorSurface(true).withOverrideColor(MaterialColor.paintedBlack)
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index dc471bfe8..bd6f2b385 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -4,6 +4,7 @@ import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicMatcher;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
@@ -188,8 +189,12 @@ public abstract class TileEntity implements ICarriable
         return new CarriedBlock(holder, currentBlock, currentMeta, this);
     }
 
-    public void notifyBlocksOfNeighborChange() {
+    protected final void updateNeighboringMatchers() {
         if (this.worldObj == null) return;
-        this.worldObj.notifyBlocksOfNeighborChange(this.tilePos, this.getBlock()); 
+        BlockLogicMatcher.updateNeighboringMatchers(this.worldObj, this.tilePos);
+    }
+
+    public interface AnimationTicking {
+        void animationTick(int particleRenderDistance, double distSqr);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
index c43ced3f4..3f2d5ffdf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
@@ -91,6 +91,7 @@ public class TileEntityDispatcher {
         addMapping(TileEntityMeshGold.class, NamespaceID.fromPool("minecraft", "mesh_gold"));
         addMapping(TileEntityStatue.class, NamespaceID.fromPool("minecraft", "statue_stone"));
         addMapping(TileEntityTimer.class, NamespaceID.fromPool("minecraft", "timer"));
+        addMapping(TileEntityThermalVent.class, NamespaceID.fromPool("minecraft", "thermal_vent"));
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
index 8ebffe931..3910bf97c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
@@ -71,7 +71,7 @@ public class TileEntityFlag extends TileEntity
     public void setFlipped(boolean flag) {
         if (this.flipped == flag) return;
         this.flipped = flag;
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     public boolean getFlipped() {
@@ -235,7 +235,7 @@ public class TileEntityFlag extends TileEntity
         items[slot] = stack;
         itemsChanged();
         setChanged();
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     private void itemsChanged() {
@@ -255,7 +255,7 @@ public class TileEntityFlag extends TileEntity
             colorHash ^= flagColors[i] << (8 * (i & 0b11));
         }
         isDirty = true;
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
index 2d8719ed7..bf755857a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -85,7 +85,7 @@ public class TileEntityMeshGold extends TileEntityMesh {
         }
         filterItem = null;
         setChanged();
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
         return success | !wasNull;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index b6f43313c..da4799864 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -45,7 +45,7 @@ public class TileEntityMobSpawner extends TileEntity {
         } catch (Exception e) {
             LOGGER.error("Failed to convert legacy mobspawner id!", e);
         }
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     public boolean anyPlayerInRange() {
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
index d3f7f5568..63e7eeb6b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
@@ -93,7 +93,7 @@ public class TileEntitySign extends TileEntity
     public void setPicture(@Nullable EnumSignPicture picture)
     {
         this.selectedPicture = (picture == null) ? 0 : picture.getId();
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
     
     public TextFormatting getColor()
@@ -106,7 +106,7 @@ public class TileEntitySign extends TileEntity
     public void setColor(TextFormatting color)
     {
         selectedColor = color.id;
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     public boolean isGlowing() {
@@ -115,7 +115,7 @@ public class TileEntitySign extends TileEntity
 
     public void setGlowing(boolean glowing) {
         this.glowing = glowing;
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     public boolean isLocked() {
@@ -124,7 +124,7 @@ public class TileEntitySign extends TileEntity
 
     public void setLocked(boolean locked) {
         this.locked = locked;
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     public void finalizeEditor(@NotNull Player editor) {
@@ -135,7 +135,7 @@ public class TileEntitySign extends TileEntity
         if (!allowColorCode) for(int i = 0; i < 4; i++) {
             signText[i] = TextFormatting.removeAllColorFormatting(signText[i]);
         }
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
index 9489ce6a2..a8371cde4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityStatue.java
@@ -125,7 +125,7 @@ public class TileEntityStatue
     public void setPose(final @NotNull Pose pose) {
         this.pose = pose;
         setChanged();
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     public void nextPose() {
@@ -141,7 +141,7 @@ public class TileEntityStatue
     public void setItemInArmorSlot(final @NotNull HumanArmorShape slot, final @Nullable ItemStack item) {
         this.armorPieces[slot.getSlotIndex()] = item;
         setChanged();
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     @Override
@@ -165,7 +165,7 @@ public class TileEntityStatue
     @Override
     public void setHeldItem(@Nullable ItemStack item) {
         this.heldItem = item;
-        this.notifyBlocksOfNeighborChange();
+        this.updateNeighboringMatchers();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityThermalVent.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityThermalVent.java
new file mode 100644
index 000000000..db0dfdbe0
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityThermalVent.java
@@ -0,0 +1,33 @@
+package net.minecraft.core.block.entity;
+
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.PacketTileEntityData;
+import org.jetbrains.annotations.NotNull;
+
+public class TileEntityThermalVent extends TileEntity implements TileEntity.AnimationTicking {
+    @Override public void readAdditionalData(@NotNull CompoundTag compoundTag) {}
+    @Override public void writeAdditionalData(@NotNull CompoundTag compoundTag) {}
+
+    @Override
+    public Packet getDescriptionPacket() {
+        return new PacketTileEntityData(this);
+    }
+
+    @Override
+    public void animationTick(int particleRenderDistance, double distSqr) {
+        if (this.worldObj == null) return;
+        if (distSqr > particleRenderDistance * particleRenderDistance * 0.75f * 0.75f) return; // Skip if further than 75% of the render distance in blocks
+
+        int throttle = 4;
+        if (distSqr > 4096) {
+            throttle = 64;
+        } else if (distSqr > 1024) {
+            throttle = 16;
+        }
+
+        if (this.worldObj.rand.nextInt(throttle) == 0) {
+            getBlock().animationTick(this.worldObj, this.tilePos, this.worldObj.rand);
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index 189a41fec..ee783315d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.block.piston;
 
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
@@ -34,9 +33,11 @@ import org.joml.Vector3d;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
+import java.util.Random;
+
 import static net.minecraft.core.block.piston.PistonCommon.*;
 
-public class BlockLogicPistonBase extends BlockLogic {
+public class BlockLogicPistonBase extends BlockLogic implements BlockLogic.MatcherDataEquivalency.Masked {
 	public final byte typeId;
 
     final byte pushLimit, pullLimit, crushLimit;
@@ -64,13 +65,8 @@ public class BlockLogicPistonBase extends BlockLogic {
     }
 
     @Override
-    protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
-        return other.getLogic() instanceof BlockLogicPistonBase otherBase && otherBase.typeId == this.typeId;
-    }
-
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & ~DIRECTION.mask;
+    public int getMatcherDataEquivalencyMask() {
+        return ~DIRECTION.mask;
     }
 
     // Piston updates:
@@ -430,11 +426,22 @@ public class BlockLogicPistonBase extends BlockLogic {
         this.signalUpdate(world, tilePos);
     }
 
+    @Override
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (isRandomTick || world.isClientSide) return;
+        this.signalUpdate(world, tilePos);
+    }
+
     @Override
     public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (world.isClientSide) return;
-        final var data = fixLegacyBaseData(world, tilePos);
-        this.signalUpdate(world, tilePos, data);
+        final int data = fixLegacyBaseData(world, tilePos);
+
+        final boolean powered = hasNeighborSignal(world, tilePos, Direction.fromId(DIRECTION.get(data)));
+        final boolean extended = IS_EXTENDED.bool(data);
+        if (powered != extended) {
+            world.scheduleBlockUpdate(tilePos, this.block, 1);
+        }
     }
 
     @Override
